diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index 34f810ec5..7b180f59f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item;
 
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntitySign;
@@ -41,7 +42,8 @@ public class ItemDye extends Item
     @Override
     public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
     {
-        if (world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_POST_PLANKS_OAK.id() || world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_WALL_PLANKS_OAK.id())
+        Block<?> block = world.getBlock(blockX, blockY, blockZ);
+        if (Block.hasLogicClass(block, BlockLogicSign.class))
         {
             TileEntitySign sign = (TileEntitySign) world.getTileEntity(blockX, blockY, blockZ);
             if ((DyeColor.WHITE.itemMeta - itemstack.getMetadata()) != sign.getColor().id)
@@ -57,14 +59,12 @@ public class ItemDye extends Item
         }
         if(itemstack.getMetadata() == DyeColor.WHITE.itemMeta)
         {
-            int id = world.getBlockId(blockX, blockY, blockZ);
-            Block<?> block = Blocks.blocksList[id];
             if (Block.hasLogicClass(block, IBonemealable.class)){
                if (((IBonemealable) block.getLogic()).onBonemealUsed(itemstack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced)){
                    return true;
                }
             }
-            if(id == Blocks.DIRT.id())
+            if(block == Blocks.DIRT)
             {
                 if(!world.isClientSide)
                 {
@@ -82,7 +82,7 @@ public class ItemDye extends Item
                 }
                 return true;
             }
-            if(id == Blocks.DIRT_SCORCHED.id())
+            if(block == Blocks.DIRT_SCORCHED)
             {
                 if (!world.isClientSide)
                 {
@@ -98,7 +98,7 @@ public class ItemDye extends Item
                 return true;
             }
 
-            if(Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.GROWS_FLOWERS))
+            if(block != null && block.hasTag(BlockTags.GROWS_FLOWERS))
             {
                 if(!world.isClientSide)
                 {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
index ec98da5a3..bd281d988 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
@@ -37,7 +37,7 @@ public class ItemFireStriker extends Item
         if(i1 == 0)
         {
             if(world.setBlockWithNotify(blockX, blockY, blockZ, Blocks.FIRE.id())){
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
+                world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
                 itemstack.damageItem(1, player);
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index a6569b680..cf66fac7b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -2,11 +2,14 @@ package net.minecraft.core.item;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.IPaintable;
 import net.minecraft.core.block.IPainted;
 import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
@@ -28,23 +31,33 @@ public class ItemPaintBrush extends Item {
 
     @Override
     public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced) {
-        if (itemstack.getMetadata() >= itemstack.getMaxDamage()) {
-            return false;
-        }
-
         final int id = world.getBlockId(blockX, blockY, blockZ);
         final Block<?> block = Blocks.getBlock(id);
 
-        if (Block.hasLogicClass(block, IPaintable.class)) {
+        if (Block.hasLogicClass(block, BlockLogicSign.class) && (player != null && player.isSneaking())) {
+            TileEntitySign sign = (TileEntitySign) world.getTileEntity(blockX, blockY, blockZ);
+            final DyeColor color = getColor(itemstack);
+            if (color.blockMeta != sign.getColor().id)
+            {
+                sign.setColor(TextFormatting.get(color.blockMeta));
+                itemstack.damageItem(1, player);
+                return true;
+            }
+        } else if (Block.hasLogicClass(block, IPaintable.class)) {
             final IPaintable paintable = (IPaintable) block.getLogic();
             if (!paintable.canBePainted()) return false;
             final DyeColor color = getColor(itemstack);
             if (color != null) {
                 if (paintable instanceof IPainted && ((IPainted)paintable).getColor(world, blockX, blockY, blockZ) == color) {
-                   return false;
+                    return false;
                 }
                 paintable.setColor(world, blockX, blockY, blockZ, color);
-                itemstack.damageItem(1, player);
+                if (itemstack.getMetadata() >= itemstack.getMaxDamage()) {
+                    setColor(itemstack, null);
+                    itemstack.setMetadata(getMaxDamage());
+                } else {
+                    itemstack.damageItem(1, player);
+                }
                 return true;
             }
         }
@@ -100,7 +113,7 @@ public class ItemPaintBrush extends Item {
 
     @Override
     public boolean showFullDurability() {
-        return true;
+        return false;
     }
 
     public int getDyeCount(ItemStack stack) {
@@ -111,8 +124,8 @@ public class ItemPaintBrush extends Item {
         stack.setMetadata(stack.getMaxDamage() - count);
     }
 
-    public DyeColor getColor(ItemStack stack) {
-        CompoundTag tag = stack.getData();
+    public static DyeColor getColor(@NotNull final ItemStack stack) {
+        final CompoundTag tag = stack.getData();
         if (tag.containsKey("Color")) {
             final int color = tag.getInteger("Color");
             if (color < 0) {
@@ -124,8 +137,8 @@ public class ItemPaintBrush extends Item {
         }
     }
 
-    public void setColor(ItemStack stack, DyeColor color) {
-        CompoundTag tag = stack.getData();
+    public static void setColor(@NotNull final ItemStack stack, @Nullable final DyeColor color) {
+        final CompoundTag tag = stack.getData();
         if (color == null) {
             tag.putInt("Color", -1);
         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
new file mode 100644
index 000000000..3a00fd3ae
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
@@ -0,0 +1,69 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class ItemSignPainted extends ItemSign{
+    public ItemSignPainted(String name, String namespaceId, int id) {
+        super(name, namespaceId, id);
+    }
+
+    @Override
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
+    {
+        int sideHit = side.getId();
+        if(side == Side.BOTTOM)
+        {
+            return false;
+        }
+        if(!world.getBlockMaterial(blockX, blockY, blockZ).isSolid())
+        {
+            return false;
+        }
+
+        if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+            blockX += side.getOffsetX();
+            blockY += side.getOffsetY();
+            blockZ += side.getOffsetZ();
+        }
+        if(blockY < 0 || blockY >= world.getHeightBlocks()) {
+            return false;
+        }
+        if(!Blocks.SIGN_POST_PLANKS_OAK_PAINTED.canPlaceBlockAt(world, blockX, blockY, blockZ))
+        {
+            return false;
+        }
+        if(sideHit == 1)
+        {
+            int direction = MathHelper.floor((double)(((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf;
+            world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.SIGN_POST_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
+            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.id(), Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(itemstack.getMetadata())) | direction);
+        } else
+        {
+            world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
+            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED.id(), Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(itemstack.getMetadata())) | sideHit);
+        }
+        itemstack.consumeItem(player);
+        TileEntitySign tileentitysign = (TileEntitySign)world.getTileEntity(blockX, blockY, blockZ);
+        if(tileentitysign != null)
+        {
+            tileentitysign.setOwner(player);
+            player.displaySignEditorScreen(tileentitysign);
+        }
+        return true;
+    }
+
+    @Override
+    public String getLanguageKey(ItemStack itemstack)
+    {
+        return super.getKey() + "." + DyeColor.colorFromItemMeta(itemstack.getMetadata()).colorID;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index e35a78c2b..8b55d1ad4 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -200,6 +200,7 @@ public final class Items {
     public static Item STATUE_GRANITE;
     public static Item STATUE_MARBLE;
     public static Item STATUE_PIGMAN;
+    public static Item SIGN_PAINTED;
 
     private static boolean hasInit = false;
     public static void init(){
@@ -420,5 +421,6 @@ public final class Items {
         STATUE_GRANITE = new ItemStatue("statue.granite", "minecraft:item/statue_granite", 16546, Blocks.STATUE_GRANITE_LOWER, Blocks.STATUE_GRANITE_UPPER);
         STATUE_MARBLE = new ItemStatue("statue.marble", "minecraft:item/statue_marble", 16547, Blocks.STATUE_MARBLE_LOWER, Blocks.STATUE_MARBLE_UPPER);
         STATUE_PIGMAN = new ItemStatue("statue.pigman", "minecraft:item/statue_pigman", 16548, Blocks.STATUE_PIGMAN_LOWER, Blocks.STATUE_PIGMAN_UPPER);
+        SIGN_PAINTED = (new ItemSignPainted("sign.painted", "minecraft:item/sign_painted", 16549));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java b/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
index 247e19e52..f6f6f52df 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
@@ -14,6 +14,7 @@ import java.nio.charset.StandardCharsets;
 import java.nio.file.Files;
 import java.util.ArrayList;
 import java.util.List;
+import java.util.zip.ZipEntry;
 import java.util.zip.ZipFile;
 
 /**
@@ -114,7 +115,16 @@ public class LanguageSeeker {
                         // Don't handle this zip file with try-with-resources since
                         // it is meant to be handled by the Language instance itself.
                         ZipFile zip = new ZipFile(file);
-                        try (InputStream stream = zip.getInputStream(zip.getEntry("lang_info.json"))) {
+                        ZipEntry entry = zip.getEntry("lang_info.json");
+                        if (entry == null) {
+                            LOGGER.error("Language pack '{}' is missing a `lang_info.json` file!", file);
+                            continue;
+                        }
+                        try (InputStream stream = zip.getInputStream(entry)) {
+                            if (stream == null) {
+                                LOGGER.error("Language pack '{}' could not read `lang_info.json` file as stream!", file);
+                                continue;
+                            }
                             String content = readInputString(stream);
                             JsonObject json = JsonParser.instance.parseString(content);
                             String langId = json.getString("id");
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java b/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java
index 746220976..b5ba0ba8f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java
@@ -12,10 +12,12 @@ import java.util.Collections;
 import java.util.function.Supplier;
 
 public interface CommandSource {
-    Collection<String> getPlayerNames();
+    Collection<String> getPlayerUsernames();
+
+    Collection<String> getPlayerNicknames();
 
     default Collection<String> getChatSuggestions() {
-        return this.getPlayerNames();
+        return this.getPlayerUsernames();
     }
 
     default Collection<String> getEntitySuggestions() {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntity.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntity.java
index 51e212cbd..362f41cd6 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntity.java
@@ -2,6 +2,7 @@ package net.minecraft.core.net.command.arguments;
 
 import com.mojang.brigadier.StringReader;
 import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.arguments.ArgumentTypeString;
 import com.mojang.brigadier.context.CommandContext;
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.brigadier.suggestion.Suggestions;
@@ -20,28 +21,31 @@ import java.util.concurrent.CompletableFuture;
 public class ArgumentTypeEntity implements ArgumentType<EntitySelector> {
     private static final Collection<String> EXAMPLES = Arrays.asList("Player", "0123", "@e", "@e[type=foo]", EntitySelector.ENTITY_PREFIX + "11203");
 
-    private final boolean singleEntity, playerOnly;
+    private final boolean singleEntity, playerOnly, showNicknames;
 
-    private ArgumentTypeEntity(boolean singleEntity, boolean playerOnly) {
+    private ArgumentTypeEntity(boolean singleEntity, boolean playerOnly, boolean showNicknames) {
         this.singleEntity = singleEntity;
         this.playerOnly = playerOnly;
+        this.showNicknames = showNicknames;
     }
 
     public static ArgumentTypeEntity entities() {
-        return new ArgumentTypeEntity(false, false);
+        return new ArgumentTypeEntity(false, false, false);
     }
 
     public static ArgumentTypeEntity entity() {
-        return new ArgumentTypeEntity(true, false);
+        return new ArgumentTypeEntity(true, false, false);
     }
 
-    public static ArgumentTypeEntity players() {
-        return new ArgumentTypeEntity(false, true);
+    public static ArgumentTypeEntity usernames() {
+        return new ArgumentTypeEntity(false, true, false);
     }
 
-    public static ArgumentTypeEntity player() {
-        return new ArgumentTypeEntity(true, true);
-    }
+    public static ArgumentTypeEntity username() {return new ArgumentTypeEntity(true, true, false);}
+
+    public static ArgumentTypeEntity nicknames() {return new ArgumentTypeEntity(false, true, true);}
+
+    public static ArgumentTypeEntity nickname() {return new ArgumentTypeEntity(true, true, true);}
 
     @Override
     public EntitySelector parse(StringReader reader) throws CommandSyntaxException {
@@ -74,7 +78,12 @@ public class ArgumentTypeEntity implements ArgumentType<EntitySelector> {
                 entitySelectorParser.parse();
             } catch (CommandSyntaxException ignored) {}
             return entitySelectorParser.fillSuggestions(builder, suggestionsBuilder -> {
-                Collection<String> collection = source.getPlayerNames();
+                Collection<String> collection;
+                if(this.showNicknames){
+                    collection = source.getPlayerNicknames();
+                } else {
+                    collection = source.getPlayerUsernames();
+                }
                 Iterable<String> iterable = this.playerOnly ? collection : new ConcatIterable<>(collection, source.getEntitySuggestions());
                 CommandHelper.suggest(iterable, suggestionsBuilder);
             });
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
index 4d390f75a..99c349963 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
@@ -2,8 +2,8 @@ package net.minecraft.core.net.command.commands;
 
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
-import com.mojang.brigadier.builder.LiteralArgumentBuilder;
-import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
+import com.mojang.brigadier.builder.ArgumentBuilderRequired;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.Achievements;
@@ -24,11 +24,11 @@ public class CommandAchievement implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType PLAYER_ALREADY_HAS_ACHIEVEMENT = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.achievement.grant.exception_already_has_achievement"));
 
     public void register(CommandDispatcher<CommandSource> dispatcher) {
-        dispatcher.register(((LiteralArgumentBuilder.<CommandSource>literal("achievement"))
+        dispatcher.register(((ArgumentBuilderLiteral.<CommandSource>literal("achievement"))
             .requires(CommandSource::hasAdmin)
-            .then((LiteralArgumentBuilder.<CommandSource>literal("grant"))
-                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", ArgumentTypeEntity.players())
-                    .then(RequiredArgumentBuilder.<CommandSource, Achievement>argument("achievement", ArgumentTypeAchievement.achievement())
+            .then((ArgumentBuilderLiteral.<CommandSource>literal("grant"))
+                .then(ArgumentBuilderRequired.<CommandSource, EntitySelector>argument("entities", ArgumentTypeEntity.usernames())
+                    .then(ArgumentBuilderRequired.<CommandSource, Achievement>argument("achievement", ArgumentTypeAchievement.achievement())
                         .executes(c -> {
                             CommandSource source = c.getSource();
                             List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(source);
@@ -54,7 +54,7 @@ public class CommandAchievement implements CommandManager.CommandRegistry {
 
                             return Command.SINGLE_SUCCESS;
                         }))
-                    .then(LiteralArgumentBuilder.<CommandSource>literal("*")
+                    .then(ArgumentBuilderLiteral.<CommandSource>literal("*")
                         .executes(c -> {
                             CommandSource source = c.getSource();
                             List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(source);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
index 724ee22fc..dced004ad 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
@@ -2,8 +2,8 @@ package net.minecraft.core.net.command.commands;
 
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
-import com.mojang.brigadier.builder.LiteralArgumentBuilder;
-import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
+import com.mojang.brigadier.builder.ArgumentBuilderRequired;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
@@ -20,18 +20,18 @@ public class CommandBiome implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE = new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.biome.locate.exception_failure", arg));
 
     public void register(CommandDispatcher<CommandSource> dispatcher) {
-        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("biome")
+        dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("biome")
                 .requires(CommandSource::hasAdmin)
-                .then(LiteralArgumentBuilder.<CommandSource>literal("get")
-                        .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("position", ArgumentTypeIntegerCoordinates.intCoordinates())
+                .then(ArgumentBuilderLiteral.<CommandSource>literal("get")
+                        .then(ArgumentBuilderRequired.<CommandSource, IntegerCoordinates>argument("position", ArgumentTypeIntegerCoordinates.intCoordinates())
                                 .executes(c -> {
                                     IntegerCoordinates position = c.getArgument("position", IntegerCoordinates.class);
                                     Biome biome = c.getSource().getWorld().getBlockBiome(position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()));
                                     c.getSource().sendTranslatableMessage("command.commands.biome.get.success", position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()), Registries.BIOMES.getKey(biome));
                                     return Command.SINGLE_SUCCESS;
                                 })))
-                .then(LiteralArgumentBuilder.<CommandSource>literal("locate")
-                        .then(RequiredArgumentBuilder.<CommandSource, Biome>argument("biome", ArgumentTypeBiome.biome())
+                .then(ArgumentBuilderLiteral.<CommandSource>literal("locate")
+                        .then(ArgumentBuilderRequired.<CommandSource, Biome>argument("biome", ArgumentTypeBiome.biome())
                                 .executes(c -> {
                                     Biome biome = c.getArgument("biome", Biome.class);
                                     Coordinates2D biomeLocation = getBiomeCoords(biome, c.getSource());
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java
index c71febbb6..51507880c 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java
@@ -2,8 +2,8 @@ package net.minecraft.core.net.command.commands;
 
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
-import com.mojang.brigadier.builder.LiteralArgumentBuilder;
-import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
+import com.mojang.brigadier.builder.ArgumentBuilderRequired;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeChunkCoordinates;
@@ -13,10 +13,10 @@ import net.minecraft.core.world.World;
 
 public class CommandChunk implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
-        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("chunk")
+        dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("chunk")
             .requires(CommandSource::hasAdmin)
-            .then(LiteralArgumentBuilder.<CommandSource>literal("reset")
-                .then(RequiredArgumentBuilder.<CommandSource, Coordinates2D>argument("position", ArgumentTypeChunkCoordinates.chunkCoordinates())
+            .then(ArgumentBuilderLiteral.<CommandSource>literal("reset")
+                .then(ArgumentBuilderRequired.<CommandSource, Coordinates2D>argument("position", ArgumentTypeChunkCoordinates.chunkCoordinates())
                     .executes(c -> {
                         CommandSource source = c.getSource();
                         Coordinates2D coordinates2D = c.getArgument("position", Coordinates2D.class);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java
index 3fbca8803..c64b4a572 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java
@@ -2,8 +2,8 @@ package net.minecraft.core.net.command.commands;
 
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
-import com.mojang.brigadier.builder.LiteralArgumentBuilder;
-import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
+import com.mojang.brigadier.builder.ArgumentBuilderRequired;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.Tag;
@@ -30,7 +30,7 @@ public class CommandClear implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clear.exception_failure"));
 
     public void register(CommandDispatcher<CommandSource> dispatcher) {
-        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("clear")
+        dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("clear")
             .requires(CommandSource::hasAdmin)
             .executes(c -> {
                 CommandSource source = c.getSource();
@@ -45,7 +45,7 @@ public class CommandClear implements CommandManager.CommandRegistry {
 
                 return Command.SINGLE_SUCCESS;
             })
-            .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("players", ArgumentTypeEntity.players())
+            .then(ArgumentBuilderRequired.<CommandSource, EntitySelector>argument("players", ArgumentTypeEntity.usernames())
                 .executes(c -> {
                     CommandSource source = c.getSource();
                     List<? extends Entity> players = c.getArgument("players", EntitySelector.class).get(source);
@@ -61,7 +61,7 @@ public class CommandClear implements CommandManager.CommandRegistry {
 
                     return Command.SINGLE_SUCCESS;
                 })
-                .then(RequiredArgumentBuilder.<CommandSource, ItemStack>argument("item", ArgumentTypeItemStack.itemStack())
+                .then(ArgumentBuilderRequired.<CommandSource, ItemStack>argument("item", ArgumentTypeItemStack.itemStack())
                     .executes(c -> {
                         CommandSource source = c.getSource();
                         List<? extends Entity> players = c.getArgument("players", EntitySelector.class).get(source);
